HDU 4944 FSF’s game 一道好题

FSF’s game

Time Limit: 9000/4500 MS (Java/Others)    Memory Limit: 131072/131072 K (Java/Others)
Total Submission(s): 727    Accepted Submission(s): 377


Problem Description
FSF has programmed a game.
In this game, players need to divide a rectangle into several same squares.
The length and width of rectangles are integer, and of course the side length of squares are integer.

After division, players can get some coins.
If players successfully divide a AxB rectangle(length: A, width: B) into KxK squares(side length: K), they can get A*B/ gcd(A/K,B/K) gold coins.
In a level, you can’t get coins twice with same method.
(For example, You can get 6 coins from 2x2(A=2,B=2) rectangle. When K=1, A*B/gcd(A/K,B/K)=2; When K=2, A*B/gcd(A/K,B/K)=4; 2+4=6; )

There are N*(N+1)/2 levels in this game, and every level is an unique rectangle. (1x1 , 2x1, 2x2, 3x1, ..., Nx(N-1), NxN)

FSF has played this game for a long time, and he finally gets all the coins in the game.
Unfortunately ,he uses an UNSIGNED 32-BIT INTEGER variable to count the number of coins.
This variable may overflow.
We want to know what the variable will be.
(In other words, the number of coins mod 2^32)
 

 

Input
There are multiply test cases.

The first line contains an integer T(T<=500000), the number of test cases

Each of the next T lines contain an integer N(N<=500000).
 

 

Output
Output a single line for each test case.

For each test case, you should output "Case #C: ". first, where C indicates the case number and counts from 1.

Then output the answer, the value of that UNSIGNED 32-BIT INTEGER variable.
 

 

Sample Input
3
1
3
100
 
Sample Output
Case #1: 1
Case #2: 30
Case #3: 15662489
Hint
In the second test case, there are six levels(1x1,1x2,1x3,2x2,2x3,3x3) Here is the details for this game: 1x1: 1(K=1); 1x2: 2(K=1); 1x3: 3(K=1); 2x2: 2(K=1), 4(K=2); 2x3: 6(K=1); 3x3: 3(K=1), 9(K=3); 1+2+3+2+4+6+3+9=30
 

 

Author
UESTC
 
 
题意:略。
思路:对于A*B/gcd(A/k,B/k) 看成 N*x/a ,其中x未知,N已知,a是N的因子。
   (因为a必然是N的因子)
        1.现在我们这样转化后,就开始一个一个枚举a了。(我们把a看成了gcd()的整体来看。)
        2.对于一个确定的a值,假设为ai,那么我们现在要做的就是找出 (N*x/a )满足要求的x来。
          并对它进行求和sum(xi/a)*N;(因为N始终没有变化呀。)
          此时 a = gcd(N/k,x/k) 可以转化成  gcd(N,x) = k*a, 
          那么,对于x的取值范围我们知道,是[1,N],求gcd(N,x)=k*a (k是>0的正整数)
          其实就是在[1,N]里,a的倍数,a , 2a , 3a ,4a,,,,,N/a*a , 正确吗?
          会不会遗漏,gcd()=k*a,就是代表最大公约数是a的倍数。
    这样的话,我们就对x进行求和了。sum = a(1+2...N/a) = a*(1+N/a)*N/a/2 =>(1+N/a)*N/2;
         最后根据式子A*x/a,那么就变成  (1+N/a)*N/a /2 * N;
       筛选,dp即可。
 1 #include<iostream>
 2 #include<stdio.h>
 3 #include<cstring>
 4 #include<cstdlib>
 5 using namespace std;
 6 typedef __int64 LL;
 7 
 8 const int maxn = 5e5+3;
 9 LL p = 1;
10 LL dp[maxn];
11 void init()
12 {
13     int j,tmp;
14     for(j=1;j<=32;j++)p=p*2;
15 
16     for(int i=1;i<maxn;i++){
17         tmp = i;
18         for(j=1;(tmp=i*j)<maxn;j++){
19             dp[tmp]=(dp[tmp]+((LL)(1+j)*(LL)j)/2)%p;
20         }
21     }
22     dp[1]=1;
23     for(int i=2;i<maxn;i++){
24         dp[i]=(dp[i-1]+dp[i]*i)%p;
25     }
26 }
27 int main()
28 {
29     int T,n;
30     init();
31     scanf("%d",&T);
32     for(int t=1;t<=T;t++)
33     {
34         scanf("%d",&n);
35         printf("Case #%d: %I64d\n",t,dp[n]);
36     }
37     return 0;
38 }

 

 
              
 

转载于:https://www.cnblogs.com/tom987690183/p/4083861.html

评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值